import java.io.*;
import java.util.Objects;

/**
 * 实现文件读行并替换
 *
 * @author Gao
 * @date 2022/6/22 15:19
 */
public class FileReaderOrWriterTest {

    public static void main(String[] args){
        String fileDirPath;
        String filePath;
        StringBuilder stringBuffer;
        BufferedReader bufReader = null;
        BufferedWriter bufWriter = null;
        try {
            //得到文件所在目录
            fileDirPath = Objects.requireNonNull(Thread.currentThread().getContextClassLoader()
                    .getResource("mapper")).getPath();
            //得到文件路径
            filePath = fileDirPath + File.separator + "test.properties";
            //读取文件
            bufReader = new BufferedReader(new FileReader(filePath));
            //储存文件内容
            stringBuffer = new StringBuilder();
            //字符缓冲流准备好了，开始读数据
            while (bufReader.ready()){
                //读取一行数据替换里面（满足条件）的内容
                String line = bufReader.readLine().replace("name=zhansan", "name=lisi").replace("age=20","age=18");
                //开始储存
                stringBuffer.append(line);
                //追加换行
                stringBuffer.append("\n");
            }
            //把储存内容写入写入文件，覆盖之前的文件
            bufWriter = new BufferedWriter(new FileWriter(filePath));
            bufWriter.write(stringBuffer.toString());
            bufWriter.flush();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            //关闭资源
            try {
                if(bufReader!=null){
                    bufReader.close();
                }
                if(bufWriter!=null){
                    bufWriter.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
            System.out.println("Close执行完毕");
        }
        System.out.println("执行完毕");
    }
}
